import cPickle,string

def fix(s):
    s = string.replace(s,'\n\n','')
    return s
    

bigarray = cPickle.load(open('house.pik','r'))

def doit(checking,cong,n):
    senators = []
    index = []
    sLUT = {}
    # update/create the senators list
    idx = 0
    for i in bigarray:
        [year,yy,resolution,date,question,author,bill_title,alternatives,rept,demt,indt,tott,votes] = i
        if not checking or year in cong:
            index.append([idx,yy,year,fix(resolution),fix(date),fix(question),fix(author),fix(bill_title),alternatives,rept,demt,indt,tott])
            idx += 1
            for vot in votes:
                for name in vot:
                    if not sLUT.has_key(name):
                        sLUT[name] = len(senators)
                        senators.append([name,fix(date),idx])
    cPickle.dump(senators,open('s-%s.pik'%n,'w'))
    cPickle.dump(index,open('i-%s.pik'%n,'w'))
    # prepare the votes list 
    votex = []
    idx = 0
    for i in bigarray:
        [year,yy,resolution,date,question,author,bill_title,alternatives,rept,demt,indt,tott,votes] = i
        if not checking or year in cong:
            # process the votes:
            idx += 1
            vote = [-2]*len(senators) # missing value...
            for j in xrange(len(votes)):
                for name in votes[j]:
                    vote[sLUT[name]] = j
            votex.append(vote)
    cPickle.dump(votex,open('v-%s.pik'%n,'w'))

congresses = [([1990],'90'),([1991,1992],'91-92'),([1993,1994],'93-94'),([1995,1996],'95-96'),([1997,1998],'97-98'),([1999,2000],'99-00'),([2001,2002],'01-02'),([2003],'03')]
for (x,n) in congresses:
    doit(1,x,n)
doit(0,[],'all')
